package untitled1;

import com.sun.j3d.utils.behaviors.mouse.MouseRotate;
import com.sun.j3d.utils.behaviors.mouse.MouseZoom;
import com.sun.j3d.utils.behaviors.mouse.MouseTranslate;
import java.awt.*;
import java.awt.event.*;
import java.io.*;
import java.net.*;
import java.awt.BorderLayout;
import java.awt.event.*;
import javax.media.j3d.*;
import javax.vecmath.*;
import javax.swing.*;
import com.sun.j3d.utils.universe.*;

public class Frame1 extends JFrame {
  Canvas3D c;
  BranchGroup juur;
  SimpleUniverse u;
  JPanel contentPane;
  BorderLayout borderLayout1 = new BorderLayout();

  /*Konstrueerin freimi*/
  public Frame1() {
    enableEvents(AWTEvent.WINDOW_EVENT_MASK);
    try {
      jbInit();
      SeadistuseAlgus3D();
      juur = LoonGraafika();
      SeadistuseLopp3D();
    }
    catch(Exception e) {
      e.printStackTrace();
    }
  }

  private void SeadistuseAlgus3D(){
    c = new Canvas3D(SimpleUniverse.getPreferredConfiguration());
    this.getContentPane().add(c,borderLayout1.CENTER);
  }

  private void SeadistuseLopp3D(){
    juur.compile();
    u = new SimpleUniverse(c);
    u.getViewingPlatform().setNominalViewingTransform();
    u.addBranchGraph(juur);
  }

  public BranchGroup LoonGraafika() {
        //Defineerin valgused
        Color3f valge = new Color3f(1.0f, 1.0f, 1.0f);
        Color3f must = new Color3f(0.0f, 0.0f, 0.0f);
        Color3f punane   = new Color3f(0.80f, 0.20f, 0.2f);
        Color3f ambientRed = new Color3f(0.2f, 0.05f, 0.0f);
        Color3f ambient = new Color3f(0.2f, 0.2f, 0.2f);
        Color3f hajumine = new Color3f(0.7f, 0.7f, 0.7f);
        Color3f specular = new Color3f(0.7f, 0.7f, 0.7f);
	Color3f taustValgus = new Color3f(0.05f, 0.05f, 0.2f);

        //Loon BranchGroupi
	BranchGroup juur = new BranchGroup();

        //Loon transformigrupi, et saaks prata kiki objekte korraga
        TransformGroup interpolaator = new TransformGroup();
        Transform3D t3d = new Transform3D();
        t3d.setScale(0.4);
        interpolaator.setTransform(t3d);
        juur.addChild(interpolaator);

        //Loon interpolaatorile keskpunkti mille mber hakkavad objektid prlema
	BoundingSphere bounds =
           new BoundingSphere(new Point3d(0.0,0.0,0.0), 100.0);
        //BoundingLeaf boundingLeaf = new BoundingLeaf(bounds);
        //interpolaator.addChild(boundingLeaf);

	//Panen tagatausta
	Background taust = new Background(taustValgus);
	taust.setApplicationBounds(bounds);
	interpolaator.addChild(taust);

        //Loon ruumi tausta/hajuvalguse allika
        AmbientLight ambValgus = new AmbientLight(valge);
        ambValgus.setInfluencingBounds(bounds);
        interpolaator.addChild(ambValgus);

        //Loon suundvalguse
        Vector3f dir = new Vector3f(-1.0f, -1.0f, -1.0f);
        DirectionalLight SuundValgus = new DirectionalLight(valge, dir);
        SuundValgus.setInfluencingBounds(bounds);
        interpolaator.addChild(SuundValgus);

        //Loon kuubi jaoks punase materjali
        Material punaneMaterjal =
           new Material(ambientRed, must, punane, specular, 75.0f);
        punaneMaterjal.setLightingEnable(true);
        Appearance punaneValimus = new Appearance();
        punaneValimus.setMaterial(punaneMaterjal);

        //Loon kuubi nurkade jaoks valge materjali
        Material valgeMaterjal =
           new Material(ambient, must, hajumine, specular, 75.0f);
        valgeMaterjal.setLightingEnable(true);
        Appearance valgeValimus = new Appearance();
        valgeValimus.setMaterial(valgeMaterjal);

        //Loon transformgrupi
	TransformGroup transformigrupp = new TransformGroup();
	transformigrupp.setCapability(TransformGroup.ALLOW_TRANSFORM_READ);
	transformigrupp.setCapability(TransformGroup.ALLOW_TRANSFORM_WRITE);
	transformigrupp.addChild(new Kuup(punaneValimus).getChild());
	transformigrupp.addChild(new Nurgad(valgeValimus).getChild());
	interpolaator.addChild(transformigrupp);

	//Panen transformgrupile hiire klge kuubi keeramiseks
	MouseRotate kaitumine1 = new MouseRotate();
	kaitumine1.setTransformGroup(transformigrupp);
	transformigrupp.addChild(kaitumine1);
	kaitumine1.setSchedulingBounds(bounds);

	//Panen hiirega suurendamise vimaluse juurde
	MouseZoom kaitumine2 = new MouseZoom();
	kaitumine2.setTransformGroup(transformigrupp);
	transformigrupp.addChild(kaitumine2);
	kaitumine2.setSchedulingBounds(bounds);

	//Panen hiirega suurendamise vimaluse juurde
	MouseTranslate kaitumine3 = new MouseTranslate();
	kaitumine3.setTransformGroup(transformigrupp);
	transformigrupp.addChild(kaitumine3);
	kaitumine3.setSchedulingBounds(bounds);
	return juur;
    }

  /*Komponentide initsialiseerimine*/
  private void jbInit() throws Exception  {
    contentPane = (JPanel) this.getContentPane();
    contentPane.setLayout(borderLayout1);
    this.setSize(new Dimension(400, 300));
    this.setTitle("Frame Title");
  }

  /*Kui aken kinni pannakse siis katkestab programm oma t*/
  protected void processWindowEvent(WindowEvent e) {
    super.processWindowEvent(e);
    if (e.getID() == WindowEvent.WINDOW_CLOSING) {
      System.exit(0);
    }
  }
}